{
  This file contains the Options form. This form is used to allow
  the user to pick one option from amongst a number of possibilities.
}

unit Options;

{$I JCL-D1.inc}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  StdCtrls, ExtCtrls, Forms, Buttons, Dialogs;

type
  TOptionsForm = class(TForm)
    OptionsRadioGroup: TRadioGroup;
    QuestionLabel: TLabel;
    OKBitBtn: TBitBtn;
    HelpBitBtn: TBitBtn;
    CancelBitBtn: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure OKBitBtnClick(Sender: TObject);
    procedure CancelBitBtnClick(Sender: TObject);
  end;

var
  OptionsForm: TOptionsForm;

implementation

{$R *.DFM}

procedure TOptionsForm.FormShow(Sender: TObject);
var
  i: Integer;
  StrLength: Integer;
  Delta_X, Delta_Y: Integer;
  StrMax: String;
  Size: Integer;
begin
  Delta_X := QuestionLabel.Left;
  Delta_Y := QuestionLabel.Top;

  StrLength := 0;
  StrMax := '';
  for i := 0 to OptionsRadioGroup.ControlCount-1 do
  begin
    if (Length(TRadioButton(OptionsRadioGroup.Controls[i]).Caption) > StrLength) then
    begin
      StrMax := TRadioButton(OptionsRadioGroup.Controls[i]).Caption;
      StrLength := Length(StrMax);
    end;
  end;
  if (Length(OptionsRadioGroup.Caption) > StrLength) then
    StrMax := OptionsRadioGroup.Caption;
  StrMax := StrMax + 'WWWW';

  Size := Canvas.TextWidth(StrMax);
  if (Size < 249) then Size := 249;

  if (QuestionLabel.Width > Size) then
  begin
    OptionsRadioGroup.Width := QuestionLabel.Width;
  end
  else
  begin
    OptionsRadioGroup.Width := Size;
    {QuestionLabel.Width := Size;}
  end;

  OptionsRadioGroup.Top := 2 * Delta_Y +
                           QuestionLabel.Height;
  OptionsRadioGroup.Height := (OptionsRadioGroup.Items.Count +1)*
                              OKBitBtn.Height;

  OKBitBtn.Top := OptionsRadioGroup.Top +
                  OptionsRadioGroup.Height +
                  QuestionLabel.Top;
  CancelBitBtn.Top := OKBitBtn.Top;
  HelpBitBtn.Top := OKBitBtn.Top;

  Height := OKBitBtn.Top + 5 * OKBitBtn.Height div 2;
  Width := 2 * Delta_X + OptionsRadioGroup.Width;


  HelpBitBtn.Left := Width - Delta_X - HelpBitBtn.Width;
  CancelBitBtn.Left := HelpBitBtn.Left - Delta_X - CancelBitBtn.Width;
  OKBitBtn.Left := CancelBitBtn.Left - Delta_X - CancelBitBtn.Width;

  Left := (Screen.Width - Width) div 2;
  Top := (Screen.Height - Height) div 2;

  TRadioButton(OptionsRadioGroup.Controls[0]).SetFocus;
end;

procedure TOptionsForm.OKBitBtnClick(Sender: TObject);
begin
{note: if ModalResult is 0, then the form DOES NOT CLOSE,
 so selection is 1..n:}
  ModalResult := OptionsRadioGroup.ItemIndex + 1;
end;

procedure TOptionsForm.CancelBitBtnClick(Sender: TObject);
begin
  ModalResult := -1;
end;


end.

